from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Directory, String, Int

Lrunzip_V0_1_0 = CommandToolBuilder(tool="lrunzip", base_command=["lrunzip"], inputs=[ToolInput(tag="in_check", input_type=Boolean(optional=True), prefix="--check", doc=InputDocumentation(doc="check integrity of file written on decompression")), ToolInput(tag="in_decompress", input_type=Boolean(optional=True), prefix="--decompress", doc=InputDocumentation(doc="decompress")), ToolInput(tag="in_encrypt", input_type=Boolean(optional=True), prefix="--encrypt", doc=InputDocumentation(doc="password protected sha512/aes128 encryption on compression")), ToolInput(tag="in_hash", input_type=Boolean(optional=True), prefix="--hash", doc=InputDocumentation(doc="display md5 hash integrity information")), ToolInput(tag="in_info", input_type=Boolean(optional=True), prefix="--info", doc=InputDocumentation(doc="show compressed file information")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="don't show compression progress")), ToolInput(tag="in_test", input_type=Boolean(optional=True), prefix="--test", doc=InputDocumentation(doc="test compressed file integrity")), ToolInput(tag="in__verbose_verbosity", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="[v], --verbose        Increase verbosity")), ToolInput(tag="in_delete", input_type=Boolean(optional=True), prefix="--delete", doc=InputDocumentation(doc="delete existing files")), ToolInput(tag="in_force", input_type=Boolean(optional=True), prefix="--force", doc=InputDocumentation(doc="force overwrite of any existing files")), ToolInput(tag="in_keep_broken", input_type=Boolean(optional=True), prefix="--keep-broken", doc=InputDocumentation(doc="keep broken or damaged output files")), ToolInput(tag="in_outfile", input_type=File(optional=True), prefix="--outfile", doc=InputDocumentation(doc="specify the output file name and/or path")), ToolInput(tag="in_outdir", input_type=Directory(optional=True), prefix="--outdir", doc=InputDocumentation(doc="specify the output directory when -o is not used")), ToolInput(tag="in_suffix", input_type=String(optional=True), prefix="--suffix", doc=InputDocumentation(doc="specify compressed suffix (default '.lrz')")), ToolInput(tag="in_bzip_two", input_type=Boolean(optional=True), prefix="--bzip2", doc=InputDocumentation(doc="bzip2 compression")), ToolInput(tag="in_gzip", input_type=Boolean(optional=True), prefix="--gzip", doc=InputDocumentation(doc="gzip compression using zlib")), ToolInput(tag="in_lzo", input_type=Boolean(optional=True), prefix="--lzo", doc=InputDocumentation(doc="lzo compression (ultra fast)")), ToolInput(tag="in_no_compress", input_type=Boolean(optional=True), prefix="--no-compress", doc=InputDocumentation(doc="no backend compression - prepare for other compressor")), ToolInput(tag="in_z_paq", input_type=Boolean(optional=True), prefix="--zpaq", doc=InputDocumentation(doc="zpaq compression (best, extreme compression, extremely slow)")), ToolInput(tag="in_level", input_type=Int(optional=True), prefix="--level", doc=InputDocumentation(doc="set lzma/bzip2/gzip compression level (1-9, default 7)")), ToolInput(tag="in_nice_level", input_type=Int(optional=True), prefix="--nice-level", doc=InputDocumentation(doc="Set nice value to value (default 19)")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Set processor count to override number of threads")), ToolInput(tag="in_max_ram", input_type=Int(optional=True), prefix="--maxram", doc=InputDocumentation(doc="Set maximim available ram in hundreds of MB\noverrides detected ammount of available ram")), ToolInput(tag="in_threshold", input_type=Boolean(optional=True), prefix="--threshold", doc=InputDocumentation(doc="Disable LZO compressibility testing")), ToolInput(tag="in_unlimited", input_type=Boolean(optional=True), prefix="--unlimited", doc=InputDocumentation(doc="Use unlimited window size beyond ramsize (potentially much slower)")), ToolInput(tag="in_window", input_type=Int(optional=True), prefix="--window", doc=InputDocumentation(doc="maximum compression window in hundreds of MB\ndefault chosen by heuristic dependent on ram and chosen compression")), ToolInput(tag="in_lr_zip", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_file_dot_dot_dot", input_type=File(), position=1, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_outfile", output_type=File(optional=True), selector=InputSelector(input_to_select="in_outfile", type_hint=File()), doc=OutputDocumentation(doc="specify the output file name and/or path")), ToolOutput(tag="out_outdir", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_outdir", type_hint=File()), doc=OutputDocumentation(doc="specify the output directory when -o is not used"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Lrunzip_V0_1_0().translate("wdl", allow_empty_container=True)

